<template>
	<view class="container details clearfix" :style="{ paddingBottom: isIphoneX ? 130 + 68 + 'rpx' : '130rpx' }">
		<!-- 自定义返回 -->
		<header-back
			:systeminfo="systeminfo"
			:navbar-data="nvabarData"
			:headerBtnPosi="headerBtnPosi"
			:isShare="isOrderShare"
		></header-back>
		<view class="container-details" :style="{ paddingTop: navbarHeight + 'px' }">
			<view class="status-text">
				<view class="view-type">{{ information.status | TextFormat }}</view>
				<text class="bage-buss" v-if="information.orderSubmitType == 3 || information.orderSubmitType == 4"
					>协销</text
				>
				<text
					class="bage-auto"
					v-if="
						information.orderSubmitType == 0 ||
							information.orderSubmitType == 1 ||
							information.orderSubmitType == 2
					"
					>自主</text
				>
			</view>
			<!-- 地址选择 -->
			<order-address
				ref="orderAddress"
				v-if="isRequest && !rechargeGoods"
				:addressData="addressData"
			></order-address>
			<!-- 商品 -->
			<goods-list
				ref="goods"
				v-if="isRequest"
				:shopOrderData="shopOrderData"
				:information="information"
				@popupClick="hanldePopupFn"
			></goods-list>
			<!-- 订单信息 -->
			<order-information ref="information" v-if="isRequest" :information="information"></order-information>
			<!-- 发票信息 -->
			<invoice-tent ref="invoice" v-if="isRequest" :orderInvoice="orderInvoice"></invoice-tent>
			<!-- 转账信息 -->
			<!-- <transfe-record ref="transfe" v-if="receiptAmount == 0 || onlinePayFlag == '1'"></transfe-record> -->
			<!-- 支付记录 -->
			<payment-record
				ref="payment"
				v-if="isRequest"
				:discernReceiptList="discernReceiptList"
				:receiptAmount="receiptAmount"
			></payment-record>
			<!-- 退款记录 -->
			<refund-record
				ref="refund"
				v-if="isRequest"
				:returnedPurchaseList="returnedPurchaseList"
				:returnedPurchaseFee="returnedPurchaseFee"
			></refund-record>
			<view
				class="clause"
				v-if="information.secondHandOrderFlag != 1 && !orderSubmitType"
				@tap.stop="openclauseConten(clauseData.id)"
				:class="clauseData.name == '无条款' ? 'noclick' : ''"
			>
				售后条款：<label class="text" :class="clauseData.name == '无条款' ? 'color-bg' : ''">{{
					clauseData.name
				}}</label>
			</view>
			<!-- 底部button -->
			<order-button
				ref="orderButton"
				v-if="isRequest"
				:status="btnStatus"
				:shareCode="shareCode"
				:order="orderInfo"
				@buttonConfirm="handButtonConfirm"
			>
			</order-button>
		</view>
		<!-- 付款弹窗 -->
		<order-model
			v-if="isPayModel"
			:payModelData="payModelData"
			:modelType="modelType"
			@cancelConfirm="hanldCancelConfirm"
			@paymentConfirm="hanldPaymentConfirm"
		/>
		<!-- 分享弹窗 -->
		<share-alert :orderId="orderId" v-if="isShareModal" @btnConfirm="onShareAppMessage"> </share-alert>
		<!-- 促销活动弹窗 -->
		<activi-popup :Promotion="handlerPros" :popupShow="popupShow"></activi-popup>
		<!-- 采美豆提示弹窗 -->
		<activityBean
			v-if="isActivityBean"
			:show="isActivityBean"
			:beansType="beansType"
			:beanNumber="beanNumber"
			@cancel="handleBeanlClick"
		></activityBean>
	</view>
</template>

<script>
import headerBack from '@/components/cm-module/headerNavbar/header-back' //自定义导航
import orderAddress from '@/components/cm-module/orderDetails/orderAddress' //地址信息
import goodsList from '@/components/cm-module/orderDetails/goodsList' //商品列表
import invoiceTent from '@/components/cm-module/orderDetails/invoiceTent' //发票信息
import orderInformation from '@/components/cm-module/orderDetails/orderInformation' //订单信息
import transfeRecord from '@/components/cm-module/orderDetails/transfeRecord' //转账信息
import paymentRecord from '@/components/cm-module/orderDetails/paymentRecord' //支付记录
import refundRecord from '@/components/cm-module/orderDetails/refundRecord' //退款记录
import orderButton from '@/components/cm-module/orderDetails/orderButton' //底部按钮
import shareAlert from '@/components/cm-module/modelAlert/shareAlert.vue' //分享弹窗
import orderModel from '@/components/cm-module/modelAlert/order-alert' //付款弹窗
import activiPopup from '@/components/cm-module/orderDetails/activipopu' //促销活动弹窗
import activityBean from '@/components/cm-module/activity/activityBean.vue'

export default {
	components: {
		headerBack,
		orderInformation,
		orderAddress,
		invoiceTent,
		goodsList,
		transfeRecord,
		paymentRecord,
		refundRecord,
		orderButton,
		shareAlert,
		orderModel,
		activiPopup,
		activityBean
	},
	data() {
		return {
			state: 0,
			userId: '',
			orderId: '',
			shareCode: '', //分享码
			shareType: '', //分享登录页过来记录的状态
			cellPhone: '', //客服电话
			payStatus: 0,
			btnStatus: 0, //按钮组件状态
			onlinePayFlag: '',
			isRequest: false, //是否加载完成渲染子组件
			isOrderShare: false,
			isShareModal: false,
			isPayModel: false,
			modelType: 0,
			orderInfo: {},
			alertOrderInfo: {},
			payModelData: {},
			addressData: {}, //地址信息初始化
			information: {}, //订单信息初始化
			shopOrderData: {}, //商品信息初始化
			orderInvoice: {}, //发票信息初始化
			returnedPurchaseList: {}, //退款信息初始化
			discernReceiptList: {}, //支付信息初始化
			receiptAmount: 0, //支付金额
			returnedPurchaseFee: 0, //退款金额
			rechargeGoods: false,
			navbarHeight: '',
			headerBtnPosi: this.setHeaderBtnPosi(), //获取设备顶部胶囊高度
			systeminfo: this.setSysteminfo(), //获取设备信息
			isIphoneX: this.$store.state.isIphoneX,
			CustomBar: this.CustomBar, // 顶部导航栏高度
			popupShow: false,
			handlerPros: {},
			nvabarData: {
				//顶部自定义导航
				showCapsule: 1, // 是否显示左上角图标   1表示显示    0表示不显示
				title: '订单详情' // 导航栏 中间的标题
			},
			clauseData: {},
			orderSubmitType: false, //自主订单
			beansType: 1,
			beanNumber: 0,
			isActivityBean: false
		}
	},
	onLoad(option) {
		console.log(option)
		this.shareType = option.type
		this.orderId = option.orderId
		if (this.shareType === 'share') {
			this.state = 0
			this.isOrderShare = true
		} else if (option.type === 'confim' || option.type === 'search') {
			this.state = 0
		} else {
			this.state = option.state
		}
		this.getHeaderTopHeight()
		this.initOrderDetaileData()
	},
	filters: {
		TextFormat(status) {
			//处理金额
			let HtmlText,
				typeTextObject = {
					0: '待确认',
					4: '交易完成',
					5: '订单完成',
					6: '已关闭',
					7: '交易全退',
					77: '交易全退',
					11: '待付款待发货',
					12: '待付款部分发货',
					13: '待付款已发货',
					21: '部分付款待发货',
					22: '部分付款部分发货',
					23: '部分付款已发货',
					31: '已付款待发货',
					32: '已付款部分发货',
					33: '已付款已发货',
					111: '待付款待发货'
				}
			Object.keys(typeTextObject).forEach(key => {
				if (key == status) {
					HtmlText = typeTextObject[key]
				}
			})
			return HtmlText
		}
	},
	methods: {
		openclauseConten(id) {
			this.$api.navigateTo(`/pages/service/sellconten?clauseId=${id}`)
		},
		async initOrderDetaileData() {
			const userInfo = await this.$api.getStorage()
			this.userId = userInfo.userId ? userInfo.userId : 0
			//初始化页面数据@参数：订单ID
			this.OrderService.QueryOrderDetails({ orderId: this.orderId, userId: this.userId })
				.then(response => {
					let data = response.data
					this.isRequest = true
					this.orderInfo = data.order
					this.shareCode = data.shareCode
					this.addressData = data.userInfo
					this.information = data.order
					this.rechargeGoods = data.order.rechargeGoods
					this.btnStatus = data.order.status
					this.payStatus = data.order.payStatus
					this.payableAmount = data.order.payableAmount
					this.shopOrderData = data.shopOrderList
					this.orderInvoice = data.orderInvoice
					this.onlinePayFlag = data.order.onlinePayFlag
					this.returnedPurchaseList = data.returnedPurchaseList
					this.discernReceiptList = data.discernReceiptList
					this.receiptAmount = data.order.receiptAmount
					this.returnedPurchaseFee = data.order.returnedPurchaseFee
					this.clauseData = data.clause
					if (
						this.information.orderSubmitType == 0 ||
						this.information.orderSubmitType == 1 ||
						this.information.orderSubmitType == 2
					) {
						this.orderSubmitType = true
					} else {
						this.orderSubmitType = false
					}
				})
				.catch(error => {
					this.$util.modal('提示', '订单查询失败，请稍后重试~', '确定', '', false, () => {
						this.$api.switchTabTo('/pages/tabBar/home/index')
					})
				})
		},
		handButtonConfirm(data) {
			//监听点击时间的按钮类型并执行...
			this.handShowAlert(data)
		},
		handShowAlert(data) {
			//判断点击的按钮类型并执行...
			switch (data.type) {
				case 'delete':
					this.handOrderDetele()
					break
				case 'cancel':
					this.handCenceConfirm()
					break
				case 'query':
					this.$api.navigateTo('/pages/user/order/order-logistics?orderId=' + this.orderId)
					break
				case 'confirm':
					this.handOrderConfirm()
					break
				case 'pay':
					this.getOrderPaymentValidation(data)
					break
				case 'confirmation':
					this.handOrderConfirmation()
					break
				case 'payment':
					this.hanldConfirmFn(data.orderId)
					break
			}
		},
		getOrderPaymentValidation(data) {
			//监听根据付款状态做操作
			this.OrderService.OrderPaymentValidation({ orderId: data.orderId })
				.then(response => {
					let dataCode = response.data.code
					this.payModelData = response.data
					switch (dataCode) {
						case 1:
							this.isPayModel = true
							this.modelType = 1
							break
						case 2:
							this.isPayModel = true
							this.modelType = 2
							break
						case -1:
							this.$util.modal('', '订单已申请全部退款，无需再付款！', '确定', '', false, () => {})
							break
						default:
							if (response.data.onlinePayFlag == '1') {
								this.$api.navigateTo(
									`/pages/user/order/order-payment?type=onlinePay&Amount=${
										response.data.pendingPayments
									}&orderId=${data.orderId}`
								)
							} else {
								this.$api.navigateTo(
									`/pages/user/order/order-payment?type=payfirm&orderId=${data.orderId}`
								)
							}
					}
				})
				.catch(error => {
					this.$util.msg(error.msg, 2000)
				})
		},
		hanldPaymentConfirm(data) {
			//余额抵扣跳转
			this.OrderService.OrderBalanceDeduction({ orderId: data.order.orderId })
				.then(response => {
					if (data.type === 2) {
						let _data = { orderId: data.order.orderId }
						this.$api.navigateTo(
							`/pages/user/order/success?type=deduction&data=${JSON.stringify({ data: _data })}`
						)
					} else {
						if (data.order.onlinePayFlag === '1') {
							this.$api.navigateTo(
								`/pages/user/order/order-payment?type=onlinePay&Amount=${
									data.order.pendingPayments
								}&orderId=${data.order.orderId}`
							)
						} else {
							this.$api.navigateTo(
								`/pages/user/order/order-payment?type=payfirm&orderId=${data.order.orderId}`
							)
						}
					}
				})
				.catch(error => {
					this.$util.msg(error.msg, 2000)
				})
		},
		hanldCancelConfirm(data) {
			//不使用余额抵扣直接跳转收银台
			if (data.onlinePayFlag == '1') {
				this.$api.navigateTo(
					`/pages/user/order/order-payment?type=onlinePay&Amount=${this.orderInfo.pendingPayments}&orderId=${
						data.orderId
					}`
				)
			} else {
				this.$api.navigateTo(`/pages/user/order/order-payment?type=payfirm&orderId=${data.orderId}`)
			}
		},
		hanldConfirmFn(orderId) {
			//确认打款供应商
			this.$util.modal(
				'提示',
				'确定委托采美平台打款给供应商吗？确定之前请务必确保货品完好？',
				'确定',
				'取消',
				true,
				() => {
					this.OrderService.confirmpayment({ orderId: orderId, userId: this.userId })
						.then(response => {
							this.$util.msg('确认成功', 2000, true, 'success')
							setTimeout(() => {
								this.getOrderDatainit(this.currentTab)
							}, 2000)
						})
						.catch(error => {
							this.$util.msg(error.msg, 2000)
						})
				}
			)
		},
		handOrderConfirm() {
			//确认收货
			this.$util.modal('提示', '是否确认收货', '确定', '取消', true, () => {
				this.OrderService.ConfirmReceipt({ orderId: this.orderId })
					.then(response => {
						this.beansType = 7
						this.beanNumber = 100
						this.isActivityBean = true
					})
					.catch(error => {
						this.$util.msg(error.msg, 2000)
					})
			})
		},
		handOrderConfirmation() {
			//确认订单
			this.$util.modal('提示', '确认此订单？', '确定', '取消', true, () => {
				this.OrderService.AffirmOrder({ orderId: this.orderId })
					.then(response => {
						this.$util.msg(response.msg, 2000, true, 'success')
						setTimeout(() => {
							this.initOrderDetaileData()
						}, 2000)
					})
					.catch(error => {
						this.$util.msg(error.msg, 2000)
					})
			})
		},
		handOrderDetele() {
			//删除订单
			this.$util.modal('提示', '确认删除该订单吗？', '确定', '取消', true, () => {
				this.OrderService.DeleteOrder({ orderId: this.orderId })
					.then(response => {
						this.$util.msg(response.msg, 2000, true, 'success')
						setTimeout(() => {
							if (this.shareType === 'share') {
								this.$api.switchTabTo('/pages/tabBar/home/index')
							} else {
								this.$api.redirectTo(`/pages/user/order/order-list?type=detele&state=${this.state}`)
							}
						}, 500)
					})
					.catch(error => {
						this.$util.msg(error.msg, 2000)
					})
			})
		},
		handCenceConfirm() {
			//取消订单
			this.$util.modal('提示', '确认取消该订单吗？', '确定', '取消', true, () => {
				this.OrderService.CancelOrder({ orderId: this.orderId })
					.then(response => {
						this.$util.msg(response.msg, 2000, true, 'success')
						this.initOrderDetaileData()
					})
					.catch(error => {
						this.$util.msg(error.msg, 2000)
					})
			})
		},
		onShareAppMessage(res) {
			//分享转发
			this.isShareModal = false
			if (res.from === 'button') {
				// 来自页面内转发按钮
			}
			return {
				title: '您有新的分享订单，快来查看吧~',
				path: `/pages/user/order/order-sharelogin?orderId=${this.orderId}&userId=${this.userId}`,
				imageUrl: 'https://img.caimei365.com/group1/M00/03/95/Cmis216Sk_SABnOFABZCgCzFV_g063.png'
			}
		},
		hanldePopupFn(data) {
			//监听活动内容
			this.popupShow = true
			this.handlerPros = data
		},
		getHeaderTopHeight() {
			let statusBarHeight = this.systeminfo.statusBarHeight // 状态栏高度
			let headerPosi = this.headerBtnPosi
			let btnPosi = {
				// 胶囊实际位置，坐标信息不是左上角原点
				height: headerPosi.height,
				width: headerPosi.width,
				// 胶囊top - 状态栏高度
				top: headerPosi.top - statusBarHeight,
				// 胶囊bottom - 胶囊height - 状态栏height （现胶囊bottom 为距离导航栏底部的长度）
				bottom: headerPosi.bottom - headerPosi.height - statusBarHeight,
				// 屏幕宽度 - 胶囊right
				right: this.systeminfo.screenWidth - headerPosi.right
			}
			this.navbarHeight = headerPosi.bottom + btnPosi.bottom // 原胶囊bottom + 现胶囊bottom
		},
		setHeaderBtnPosi() {
			// 获得胶囊按钮位置信息
			let headerBtnPosi = uni.getMenuButtonBoundingClientRect()
			return headerBtnPosi
		},
		setSysteminfo() {
			let systeminfo
			uni.getSystemInfo({
				// 获取设备信息
				success: res => {
					systeminfo = res
				}
			})
			return systeminfo
		},
		handleBeanlClick() {
			//关闭采美豆弹窗
			this.isActivityBean = false
			this.initOrderDetaileData()
		}
	},
	onShow() {}
}
</script>

<style lang="scss">
page {
	height: auto;
	background: #f7f7f7;
}
.details {
	padding-bottom: 130rpx;
}
.btn-hover {
	background: #ffffff;
}
.animation {
	/* transition: transform 0.3s ease;*/
	transition-property: transform;
	transition-duration: 0.3s;
	transition-timing-function: ease;
}
.invoice-balance {
	width: 702rpx;
	height: auto;
	padding: 0 24rpx;
	background: #ffffff;
	float: left;
	margin-top: 24rpx;
	margin-bottom: 24rpx;
	.balabce-t {
		width: 100%;
		height: 86rpx;
		line-height: 86rpx;
		font-size: $font-size-28;
		color: $text-color;
		float: left;
		.balabce-t-le {
			float: left;
			font-weight: bold;
		}
		.balabce-t-ri {
			float: right;
			display: flex;
			align-items: center;
			.money {
				display: flex;
				float: left;
			}
			.checkbox-box {
				display: flex;
				width: 60rpx;
				float: left;
				height: 100%;
				font-size: $font-size-24;
				.checkbox {
					width: 40rpx;
					text-align: right;
					box-sizing: border-box;
					text-align: center;
					text-decoration: none;
					border-radius: 0;
					-webkit-tap-highlight-color: transparent;
					overflow: hidden;
				}
			}
		}
	}
	.balabce-b {
		width: 100%;
		float: left;
		overflow: hidden;
		.balabce-b-text {
			width: 100%;
			line-height: 58rpx;
			font-size: $font-size-24;
			color: #ff2a2a;
			text-align: right;
			float: right;
		}
		&.balabce-b--hide {
			padding: 0 0;
			height: 0px;
			line-height: 0px;
		}
	}
}
.clause {
	float: right;
	font-size: 24rpx;
	color: #999999;
	margin-top: 60rpx;
	margin-right: 24rpx;
	&.noclick {
		pointer-events: none;
	}
	.text {
		color: #1890f9;
		&.color-bg {
			color: #333333;
		}
	}
}
.status-text {
	overflow: hidden;
	padding: 24rpx;
	background: #fff;
	font-size: $font-size-26;
	.view-type {
		float: left;
		color: #ff2a2a;
	}
	.bage-buss {
		display: inline-block;
		width: 72rpx;
		height: 32rpx;
		background: radial-gradient(circle, rgba(255, 39, 180, 1) 0%, rgba(193, 77, 245, 1) 100%);
		border-radius: 6rpx;
		line-height: 32rpx;
		text-align: center;
		color: #ffffff;
		margin-top: 10rpx;
		float: right;
	}
	.bage-auto {
		display: inline-block;
		width: 72rpx;
		height: 32rpx;
		background: radial-gradient(circle, rgba(255, 180, 39, 1) 0%, rgba(245, 142, 77, 1) 100%);
		border-radius: 6rpx;
		line-height: 32rpx;
		text-align: center;
		color: #ffffff;
		margin-top: 10rpx;
		float: right;
	}
}
</style>
